
struct v3
{
	int x, y, z;
	
 	v3() {}
	v3(int xx,int yy,int zz) :x(xx),y(yy),z(zz) { }
	void set(int xx,int yy,int zz) {x=xx;y=yy;z=zz;}
	const v3 operator+(const v3 &b) const { return v3(x+b.x,y+b.y,z+b.z); }
	const v3 operator-(const v3 &b) const { return v3(x-b.x,y-b.y,z-b.z); }
	const v3 operator*(int factor) const { return v3(x*factor,y*factor,z*factor); }
	const v3 operator/(int factor) const { return v3(x/factor,y/factor,z/factor); }
	const v3 avg(const v3 &b) const { return v3((x+b.x)/2,(y+b.y)/2,(z+b.z)/2); }
};

struct wall
{
	unsigned v1, v2;
};

struct bsp
{
	unsigned wallid;
	
	v3 point;
	
	bsp *neu, *seu, *swu, *nwu,
	    *ned, *sed, *swd, *nwd;
};
